    001/* ===========================================================
    002 * Orson Charts : a 3D chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C)opyright 2013-2022, by David Gilbert.  All rights reserved.
    006 *
    007 * https://github.com/jfree/orson-charts
    008 *
    009 * This program is free software: you can redistribute it and/or modify
    010 * it under the terms of the GNU General Public License as published by
    011 * the Free Software Foundation, either version 3 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This program is distributed in the hope that it will be useful,
    015 * but WITHOUT ANY WARRANTY; without even the implied warranty of
    016 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    017 * GNU General Public License for more details.
    018 *
    019 * You should have received a copy of the GNU General Public License
    020 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
    021 *
    022 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    023 * Other names may be trademarks of their respective owners.]
    024 *
    025 * If you do not wish to be bound by the terms of the GPL, an alternative
    026 * commercial license can be purchased.  For details, please see visit the
    027 * Orson Charts home page:
    028 *
    029 * http://www.object-refinery.com/orsoncharts/index.html
    030 *
    031 */
    032
    033package org.jfree.chart3d.label;
    034
    035import org.jfree.chart3d.data.category.CategoryDataset3D;
    036import org.jfree.chart3d.plot.CategoryPlot3D;
    037
    038/**
    039 * A label generator for category charts, used to create labels for the axes
    040 * and for the chart legend.  The ({@link StandardCategoryLabelGenerator}) class
    041 * provides the default implementation.
    042 * <br><br>
    043 * Note that a different generator is used for <strong>item labels</strong> in
    044 * a {@link CategoryPlot3D} - see the {@link CategoryItemLabelGenerator}
    045 * interface.
    046 *
    047 * @param <S> The series key type (must implement Comparable).
    048 * @param <R> The row key type (must implement Comparable).
    049 * @param <C> The column key type (must implement Comparable).
    050 *
    051 * @since 1.2
    052 */
    053public interface CategoryLabelGenerator<S extends Comparable<S>,
    054        R extends Comparable<R>, C extends Comparable<C>>  {
    055
    056    /**
    057     * Generates a label for one series in a {@link CategoryDataset3D}.
    058     *
    059     * @param dataset  the dataset ({@code null} not permitted).
    060     * @param seriesKey  the series key ({@code null} not permitted).
    061     *
    062     * @return The series label (possibly {@code null}).
    063     */
    064    String generateSeriesLabel(CategoryDataset3D<S, R, C> dataset, S seriesKey);
    065
    066    /**
    067     * Generates a label for one row in a {@link CategoryDataset3D}.
    068     *
    069     * @param dataset  the dataset ({@code null} not permitted).
    070     * @param rowKey  the key ({@code null} not permitted).
    071     *
    072     * @return The row label (possibly {@code null}).
    073     */
    074    String generateRowLabel(CategoryDataset3D<S, R, C> dataset, R rowKey);
    075
    076    /**
    077     * Generates a label for one column in a {@link CategoryDataset3D}.
    078     *
    079     * @param dataset  the dataset ({@code null} not permitted).
    080     * @param columnKey  the key ({@code null} not permitted).
    081     *
    082     * @return The column label (possibly {@code null}).
    083     */
    084    String generateColumnLabel(CategoryDataset3D<S, R, C> dataset, C columnKey);
    085
    086}